package org.linda.Database
import org.linda.Core._
import org.linda.LindaTypes.LindaType
import java.util.Random

class Database  {
	protected val db = scala.collection.mutable.Map[String, List[List[LindaType]]]  ()
 
 def out (signature : String, tuple: List[LindaType]) : Boolean = 
    {
     //if list with such signature exists, add new tuple to it
      if (db.contains(signature)) db(signature) = tuple :: db(signature)  
    //if list with such signature does not exist create new list of tuples
    else db(signature) = List[List[LindaType]](tuple) 
  
    
    println(db)
    
    
    true
    }
 
 def out (tupleList : List[List[LindaType]]) : Boolean = {
   val signature = LindaTuple.getSignature(tupleList(0))
   if (db.contains(signature)) 
	  db(signature) = db(signature) ::: tupleList
   else
     db(signature) = tupleList
   println(db)
   true
 }
 
 def contains (key : String) : Boolean = {
    db.contains(key)
  }
 
 def in (antiTuple : List[LindaType]) : List[LindaType]= 
  {
    println(" db in")
    val signature = LindaTuple.getSignature(antiTuple)  //отримання сигнатури кортежу
    val tuple = chooseTuple(find(antiTuple)) //пошук і вибір кортежу
      if (db(signature).length == 1) //якщо вибраний кортеж єдиний з такою сигнатурою
    	 db - signature     //то видалити сигнатуру з відображення
      else
        db(signature) = deleteTuple(tuple,db(signature)) //видалення кортежу з бази даних
      
      println(db)
      
      tuple  //повернути кортеж
    }

 def rd (antiTuple : List[LindaType]) : List[LindaType]= 
  {
    val signature = LindaTuple.getSignature(antiTuple)
    val tuple = chooseTuple(find(antiTuple))
      tuple
    }  
 
 def collect (antiTuple : List[LindaType]) : List[List[LindaType]]= 
  {
    
    println(" db collect")
    
    val signature = LindaTuple.getSignature(antiTuple)
    val tuples = find(antiTuple)
      if (db(signature).length == 1)
    	 db - signature
      else
        tuples.foreach(tuple => db(signature) = deleteTuple(tuple,db(signature)))
      
      println(db)
      
      tuples
    }
 
 def copycollect (antiTuple : List[LindaType]) : List[List[LindaType]]= 
  {
    
    println(" db copycollect")
    
    val signature = LindaTuple.getSignature(antiTuple)
    val tuples = find(antiTuple)
      
      println(db)
      
      tuples
    }
 
 def query (length : Int, antiTuple : List[LindaType]) : List[List[LindaType]]= 
  {
    
    println(" db query")
    
    val signature = LindaTuple.getSignature(antiTuple)
    val tuples = find(antiTuple) take length
      if (db(signature).length == 1)
    	 db - signature
      else
        tuples.foreach(tuple => db(signature) = deleteTuple(tuple,db(signature)))
      
      println(db)
      
      tuples
    }
 
 def queryp (length : Int, antiTuple : List[LindaType]) : List[List[LindaType]]= 
  {
    
    println(" db queryp")
    
    val signature = LindaTuple.getSignature(antiTuple)
    val tuples = find(antiTuple) take length
      
      println(db)
      
    tuples
    } 
 
 def copyquery (length : Int, antiTuple : List[LindaType]) : List[List[LindaType]]= 
  {
    
    println(" db copyquery")
    
    val signature = LindaTuple.getSignature(antiTuple)
    val tuples = find(antiTuple) take length
      
      println(db)
      
      tuples
    }
 
 def find (antiTuple: List[LindaType]) = 
  	{
  	 if (db.contains(LindaTuple.getSignature(antiTuple))) 
      {
  	  val tupleList = db(LindaTuple.getSignature(antiTuple))

      //comparing tuples with antituple in cycle
      for (tuple <- tupleList if List.forall2(antiTuple,tuple) (compareElements(_,_)) ) yield tuple
      }
    else List()
      
    }
  
  
  //function for comparison of 2 tuples
  def compareElements (x: LindaType, y: LindaType) : Boolean = 
    {
    if (x.isFormal) {
      x.getType == y.getType
    }
    else 
      {
        x == y
      }
    }
  
  //if find function returns more than one tuple, chose arbitrary one of them
  def chooseTuple (tupleList : List[List[LindaType]]) : List[LindaType]= 
    {
      if (tupleList.length > 1) 
        {
         // println(tupleList)
          //println("more than 1")
          val rand = new Random(System.currentTimeMillis())
          tupleList(rand.nextInt(tupleList.length))
        }
      else 
        if (tupleList.isEmpty)
        	List()
        else  
        	tupleList(0)
    }
  
  //deleting tuple from database
  def deleteTuple(tuple : List[LindaType], tupleList : List[List[LindaType]]) : List[List[LindaType]]=
  	{
  	  if (tuple == tupleList.head) tupleList.tail
     else tupleList.head :: deleteTuple(tuple,tupleList.tail)
    }
 
  //return the number of tuples with same signature
  def getLength (tuple : List[LindaType]) : Int = 
  {
    db(LindaTuple.getSignature(tuple)).length
  }
  
  //deleting duplicates from the list
  def removeDuplicates(xs: List[List[LindaType]]): List[List[LindaType]] = 
    {
      if (xs.isEmpty) xs
      else
    	  xs.head :: removeDuplicates(xs.tail filter (x => x != xs.head))
  	}
 
}
