package org.linda.LindaTypes

case class LindaInteger (Integer : Int) extends LindaType {
  val Value = Integer
  
 //getting class identifier
  override def getType = "integer"
  override def toString = Value+""
  
  //implementing base arithmetical operations for class
  def + (that: LindaInteger): LindaInteger =
    new LindaInteger(Value + that.Value)
  def + (i: Int):LindaInteger =
    new LindaInteger (Value + i)
  def - (that: LindaInteger) : LindaInteger = 
    new LindaInteger (Value - that.Value)
  def - (i: Int):LindaInteger =
    new LindaInteger (Value - i)
  def * (that: LindaInteger) : LindaInteger = 
    new LindaInteger (Value * that.Value)
  def * (i: Int):LindaInteger =
    new LindaInteger (Value * i)
  def / (that: LindaInteger) : LindaInteger = 
    new LindaInteger (Value / that.Value)
  def / (i: Int):LindaInteger =
    new LindaInteger (Value / i)
  def % (that: LindaInteger) : LindaInteger = 
    new LindaInteger (Value % that.Value)
  def % (i: Int):LindaInteger =
    new LindaInteger (Value % i)
  
  //defining equals method
  override def equals (other : Any) = other match {
    case that: LindaInteger =>
      (that canEqual this) &&
      (this.Value == that.Value)
    case _ =>
      false
    }
  //helper method for object equality
  def canEqual (other: Any) = other.isInstanceOf[LindaInteger]
  //override def hashCode: Int  = 23 * 
}

object LindaInteger {
  implicit def intToLindaInteger (x: Int) = new LindaInteger (x)
}
