package org.linda.Server
import org.linda.Database._
import org.linda.Core._
import org.linda.LindaTypes.LindaType
import java.io._
import java.net.{InetAddress,ServerSocket,Socket,SocketException}
import java.util.Random


class LindaServer {
  private val db = new Database
  
  def start (port:Int)
  {
    try {
      println("server has started")
      //val t = Thread.currentThread()
      //println(t.getPriority)
      val listener = new ServerSocket(port);
      //listener.
      while (true)
          new ServerThread(listener.accept(),db).start();
      //new ServerThread(listener.accept).start()
      
      listener.close()
    }
    catch {
      case e: IOException =>
        System.err.println("Could not listen on port: "+port+".");
        System.exit(-1)
    }
  }

  def stop ()
  {
    println("stop code here")
  }


}

case class ServerThread(socket: Socket, db : Database) extends Thread("ServerThread") {

  
  override def run(): Unit = {
    try {
      val outStream = new ObjectOutputStream(new DataOutputStream(socket.getOutputStream()))
      val inStream = new ObjectInputStream(new DataInputStream(socket.getInputStream()))
      //val filter = in.readObject().asInstanceOf[Int => Boolean]
      //println(inStream.readObject()+" in server now")
      val (operation,signature,tuple) = inStream.readObject()
      //println(operation)
      db.synchronized {
      operation match  {
        case "out" => db.out(signature.asInstanceOf[String],tuple.asInstanceOf[List[LindaType]]); db.notifyAll()
        case "in" =>  {
          while (!(db.contains(signature.asInstanceOf[String])) && (db.find(tuple.asInstanceOf[List[LindaType]]).isEmpty)) 
            db.wait()
          outStream.writeObject(db.in(tuple.asInstanceOf[List[LindaType]]))
        }
        case _ => println("nothing matched")
      }
      }
      //val test=inStream.readObject().asInstanceOf[String]
      //println("in the thread") 
      outStream.close();
      inStream.close();
      socket.close()
    }
    catch {
      case e: SocketException =>
        () // avoid stack trace when stopping a client with Ctrl-C
      case e: IOException =>
        e.printStackTrace();
    }
  }

}